#include <stdio.h>

using namespace std;

int main(){
    int n, k;
    scanf("%d %d", &n, &k);
    int a[n];
    for (int i = 0; i < n; i++){
        scanf("%d", &a[i]);
    }
    bool b[n] = {false};
    int i = 0;
    while (i < n-1 && k > 0){
        if (a[i] > a[i+1]){
            b[i] = true;
            k--;
        }
        else
            b[i] = false;
        i++;
    }
    for (i = 0; i < n; i++){
        if (!b[i]) printf("%d ", a[i]);
    }
    return 0;
}